Index: /java/main/src/main/java/com/framsticks/params/ReflectionAccess.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/ReflectionAccess.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/params/ReflectionAccess.java	(revision 90)
@@ -4,7 +4,8 @@
 import java.lang.reflect.InvocationTargetException;
 import java.lang.reflect.Method;
+import java.util.ArrayList;
 import java.util.Collections;
+import java.util.Comparator;
 import java.util.HashMap;
-import java.util.LinkedList;
 import java.util.List;
 import java.util.Map;
@@ -15,4 +16,5 @@
 
 import com.framsticks.params.annotations.AutoAppendAnnotation;
+import com.framsticks.params.types.ProcedureParam;
 import com.framsticks.util.FramsticksException;
 import com.framsticks.util.lang.Pair;
@@ -31,5 +33,5 @@
 	private final static Logger log = Logger.getLogger(ReflectionAccess.class.getName());
 
-	protected final Class<?> reflectedClass;
+	protected final Class<?> javaClass;
 	protected final Backend backend;
 
@@ -41,7 +43,7 @@
 		protected static final Map<Pair<Class<?>, FramsClass>, Backend> synchronizedCache = Collections.synchronizedMap(new HashMap<Pair<Class<?>, FramsClass>, Backend>());
 
-		public static class ReflectedValueParam {
-			public ReflectedSetter setter;
-			public ReflectedGetter getter;
+
+		public interface ReflectedGetter {
+			public <T> T get(Object object, Class<T> type) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException;
 		}
 
@@ -50,18 +52,17 @@
 		}
 
-		public interface ReflectedGetter {
-			public abstract <T> T get(Object object, Class<T> type) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException;
-		}
-
-		protected final Map<ValueParam, ReflectedValueParam> params;
-		protected final List<Method> autoAppendMethods;
+		public interface ReflectedCaller {
+			public Object call(Object object, Object[] arguments) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException;
+		}
+
+		protected final Map<ValueParam, ReflectedSetter> setters = new HashMap<>();
+		protected final Map<ValueParam, ReflectedGetter> getters = new HashMap<>();
+		protected final Map<ProcedureParam, ReflectedCaller> callers = new HashMap<>();
+		protected final List<Method> autoAppendMethods = new ArrayList<>();
 
 		/**
 		 * @param params
 		 */
-		public Backend(Map<ValueParam, ReflectedValueParam> params, List<Method> autoAppendMethods) {
-			// this.params = Collections.unmodifiableMap(params);
-			this.params = params;
-			this.autoAppendMethods = autoAppendMethods;
+		public Backend() {
 		}
 
@@ -75,9 +76,27 @@
 
 			log.debug("constructing backend for " + id);
-			final Map<ValueParam, ReflectedValueParam> params = new HashMap<>();
-
-			Map<String, ParamCandidate> candidates = ParamCandidate.getAllCandidates(reflectedClass);
-
-			try {
+			backend = new Backend();
+
+			Map<String, ParamCandidate> candidates = ParamCandidate.getAllCandidates(reflectedClass).getCandidates();
+
+			try {
+				for (final ProcedureParam pp : filterInstanceof(framsClass.getParamEntries(), ProcedureParam.class)) {
+					if (!candidates.containsKey(pp.getId())) {
+						log.trace("java class does implement method " + pp);
+						continue;
+					}
+					ParamCandidate pc = candidates.get(pp.getId());
+					final Method method = pc.getCaller();
+
+					backend.callers.put(pp, new ReflectedCaller() {
+
+						@Override
+						public Object call(Object object, Object[] arguments) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException {
+							return method.invoke(object, arguments);
+						}
+					});
+
+				}
+
 				for (final ValueParam vp : filterInstanceof(framsClass.getParamEntries(), ValueParam.class)) {
 					if (!candidates.containsKey(vp.getId())) {
@@ -92,17 +111,15 @@
 					}
 
-					ReflectedValueParam rvp = new ReflectedValueParam();
-					params.put(vp, rvp);
 					final boolean primitive = pc.isPrimitive();
 					if (pc.getField() != null) {
 						final Field f = pc.getField();
-						rvp.getter = new ReflectedGetter() {
+						backend.getters.put(vp, new ReflectedGetter() {
 							@Override
 							public <T> T get(Object object, Class<T> type) throws IllegalArgumentException, IllegalAccessException {
 								return type.cast(f.get(object));
 							}
-						};
+						});
 						if (!pc.isFinal()) {
-							rvp.setter = new ReflectedSetter() {
+							backend.setters.put(vp, new ReflectedSetter() {
 								@Override
 								public <T> void set(Object object, T value) throws IllegalArgumentException, IllegalAccessException {
@@ -112,19 +129,19 @@
 									f.set(object, value);
 								}
-							};
+							});
 						}
 					} else {
 						final Method g = pc.getGetter();
 
-						rvp.getter = new ReflectedGetter() {
+						backend.getters.put(vp, new ReflectedGetter() {
 							@Override
 							public <T> T get(Object object, Class<T> type) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException {
 								return type.cast(g.invoke(object));
 							}
-						};
+						});
 
 						if (!pc.isFinal()) {
 							final Method s = pc.getSetter();
-							rvp.setter = new ReflectedSetter() {
+							backend.setters.put(vp, new ReflectedSetter() {
 								@Override
 								public <T> void set(Object object, T value) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException {
@@ -134,5 +151,5 @@
 									s.invoke(object, value);
 								}
-							};
+							});
 						}
 					}
@@ -141,6 +158,4 @@
 				throw e.arg("java class", reflectedClass).arg("framsClass", framsClass);
 			}
-
-			List<Method> autoAppendMethods = new LinkedList<>();
 
 			Class<?> javaClass = reflectedClass;
@@ -156,5 +171,5 @@
 						throw new ConstructionException().msg("invalid number of arguments in AutoAppend marked method").arg("method", m).arg("arguments", args.length);
 					}
-					autoAppendMethods.add(m);
+					backend.autoAppendMethods.add(m);
 				}
 
@@ -162,5 +177,20 @@
 			}
 
-			backend = new Backend(params, autoAppendMethods);
+			Collections.sort(backend.autoAppendMethods, new Comparator<Method>() {
+
+				@Override
+				public int compare(Method m0, Method m1) {
+					Class<?> arg0 = m0.getParameterTypes()[0];
+					Class<?> arg1 = m1.getParameterTypes()[0];
+					if (arg0.isAssignableFrom(arg1)) {
+						return 1;
+					}
+					if (arg1.isAssignableFrom(arg0)) {
+						return -1;
+					}
+					return 0;
+				}
+			});
+
 			synchronizedCache.put(id, backend);
 			return backend;
@@ -194,12 +224,8 @@
 	public ReflectionAccess(Class<?> reflectedClass, FramsClass framsClass) throws ConstructionException {
 		super(framsClass);
-		this.reflectedClass = reflectedClass;
+		this.javaClass = reflectedClass;
 		this.backend = Backend.getOrCreateFor(reflectedClass, framsClass);
-		// log.info("created ReflectionAccess " + this);
-	}
-
-	// private static String accessorName(boolean get, String id) {
-	//	return (get ? "get" : "set") + id.substring(0, 1).toUpperCase() + id.substring(1);
-	// }
+	}
+
 
 	@Override
@@ -211,5 +237,5 @@
 				}
 
-				return backend.params.get(param).getter.get(object, type);
+				return backend.getters.get(param).get(object, type);
 			} catch (IllegalAccessException | IllegalArgumentException | InvocationTargetException e) {
 				throw new FramsticksException().msg("failed to get").cause(e);
@@ -231,7 +257,7 @@
 					throw new FramsticksException().msg("no object set");
 				}
-				Backend.ReflectedSetter s = backend.params.get(param).setter;
+				Backend.ReflectedSetter s = backend.setters.get(param);
 				if (s == null) {
-					throw new FramsticksException().msg("trying to set final");
+					throw new FramsticksException().msg("trying to set unsettable");
 				}
 				s.set(object, value);
@@ -241,4 +267,29 @@
 		} catch (FramsticksException e) {
 			throw e.arg("param", param).arg("value", value).arg("access", this);
+		}
+	}
+
+	@Override
+	public Object call(String id, Object[] arguments) {
+		return call(framsClass.getParamEntry(id, ProcedureParam.class), arguments);
+	}
+
+	@Override
+	public Object call(ProcedureParam param, Object[] arguments) {
+		try {
+			try {
+				if (object == null) {
+					throw new FramsticksException().msg("no object set");
+				}
+				Backend.ReflectedCaller c = backend.callers.get(param);
+				if (c == null) {
+					throw new FramsticksException().msg("method is not bound");
+				}
+				return c.call(object, arguments);
+			} catch (IllegalArgumentException | IllegalAccessException | InvocationTargetException e) {
+				throw new FramsticksException().msg("failed to call").cause(e);
+			}
+		} catch (FramsticksException e) {
+			throw e.arg("param", param).arg("access", this);
 		}
 	}
@@ -273,5 +324,5 @@
 	@Override
 	public ReflectionAccess select(Object object) {
-		assert object == null || reflectedClass.isInstance(object);
+		assert object == null || javaClass.isInstance(object);
 		this.object = object;
 		return this;
@@ -302,5 +353,5 @@
 	@Override
 	public ReflectionAccess cloneAccess() throws ConstructionException {
-		return new ReflectionAccess(reflectedClass, framsClass);
+		return new ReflectionAccess(javaClass, framsClass);
 	}
 
@@ -308,9 +359,9 @@
 	public Object createAccessee() {
 		try {
-			return reflectedClass.newInstance();
+			return javaClass.newInstance();
 		} catch (InstantiationException | IllegalAccessException e) {
 			e.printStackTrace();
 		}
-		log.fatal("failed to create reflected object of class " + reflectedClass.getCanonicalName() + " for frams type " + framsClass.getId());
+		log.fatal("failed to create reflected object of class " + javaClass.getCanonicalName() + " for frams type " + framsClass.getId());
 		return null;
 	}
@@ -332,4 +383,5 @@
 			if (m.getParameterTypes()[0].isAssignableFrom(value.getClass())) {
 				try {
+					log.trace("auto appending with value " + value + " with method " + m);
 					m.invoke(object, value);
 					return true;
@@ -341,4 +393,5 @@
 		return false;
 	}
+
 }
 
Index: /java/main/src/main/java/com/framsticks/params/Registry.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/Registry.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/params/Registry.java	(revision 90)
@@ -4,50 +4,74 @@
 
 import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
 import com.framsticks.util.DoubleMap;
 import com.framsticks.util.FramsticksException;
 
+import java.util.HashMap;
+import java.util.Map;
 import java.util.Set;
+
+import javax.annotation.Nonnull;
 
 /**
  * Author: Piotr Śniegowski
  */
+@FramsClassAnnotation
 public class Registry {
 	private static final Logger log = Logger.getLogger(Registry.class.getName());
 
-	// protected void internalRegisterClass(FramsClass framsClass, @Nullable Class<?> javaClass) {
-	// 	assert framsClass.getName() != null;
-	// 	assert framsClass.getId() != null;
-	// 	infoCacheByName.put(framsClass.getName(), framsClass);
-	// 	infoCacheById.put(framsClass.getId(), framsClass);
-
-	// 	if (javaClass != null) {
-	// 		reflectedClasses.put(framsClass, javaClass);
-	// 		infoCacheByJavaName.put(javaClass.getCanonicalName(), framsClass);
-	// 	}
-	// }
 	protected final DoubleMap<String, Class<?>> javaClasses = new DoubleMap<>();
 	protected final DoubleMap<String, FramsClass> framsClasses = new DoubleMap<>();
+	protected final Map<Class<?>, FramsClass> javaToFramsAssociation = new HashMap<>();
 
-	public void registerReflectedClass(String name, String id, Class<?> reflectedClass) {
-		javaClasses.put(id, name, reflectedClass);
+	/**
+	 *
+	 */
+	public Registry() {
+		// registerAndBuild(Registry.class);
+		// registerAndBuild(FramsClass.class);
+		// registerAndBuild(Param.class);
 	}
 
-	public Registry registerAndBuild(Class<?> reflectedClass) {
-		register(reflectedClass);
-		putInfoIntoCache(FramsClass.build().forClass(reflectedClass));
+	public void registerReflectedClass(String name, String id, Class<?> javaClass) {
+		javaClasses.put(id, name, javaClass);
+	}
+
+	public void associate(Class<?> javaClass, FramsClass framsClass) {
+		javaToFramsAssociation.put(javaClass, framsClass);
+	}
+
+	public Registry registerAndBuild(Class<?> javaClass) {
+		register(javaClass);
+		associate(javaClass, putFramsClass(FramsClass.build().forClass(javaClass)));
 		return this;
 	}
 
-	public Registry register(Class<?> reflectedClass) {
-		FramsClassAnnotation a = reflectedClass.getAnnotation(FramsClassAnnotation.class);
+	public Registry register(Class<?> javaClass) {
+		FramsClassAnnotation a = javaClass.getAnnotation(FramsClassAnnotation.class);
 		if (a == null) {
-			throw new FramsticksException().msg("class is not annotated").arg("class", reflectedClass);
+			throw new FramsticksException().msg("class is not annotated").arg("class", javaClass);
 		}
 
-		registerReflectedClass(FramsClassBuilder.getName(a, reflectedClass), FramsClassBuilder.getId(a, reflectedClass), reflectedClass);
+		registerReflectedClass(FramsClassBuilder.getName(a, javaClass), FramsClassBuilder.getId(a, javaClass), javaClass);
 		return this;
 	}
 
-	public AccessInterface createAccess(String name, FramsClass framsClass) throws ConstructionException {
+	public @Nonnull ReflectionAccess createAccess(Class<?> javaClass) throws ConstructionException {
+		try {
+			if (!javaClasses.containsValue(javaClass)) {
+				throw new FramsticksException().msg("java class is not registered");
+			}
+			if (!javaToFramsAssociation.containsKey(javaClass)) {
+				throw new FramsticksException().msg("java class is not associated with any frams class");
+			}
+			return new ReflectionAccess(javaClass, javaToFramsAssociation.get(javaClass));
+		}
+		catch (FramsticksException e) {
+			throw new FramsticksException().msg("failed to create access for java class").arg("class", javaClass).cause(e);
+		}
+	}
+
+	public @Nonnull AccessInterface createAccess(String name, FramsClass framsClass) throws ConstructionException {
 		// assert framsClasses.containsValue(framsClass);
 		if (javaClasses.containsKey(name)) {
@@ -57,37 +81,34 @@
 	}
 
-	public void putInfoIntoCache(FramsClass framsClass) {
+	public FramsClass putFramsClass(FramsClass framsClass) {
 		log.debug("caching info for " + framsClass);
 		framsClasses.put(framsClass.getId(), framsClass.getName(), framsClass);
+		return framsClass;
 	}
 
-	public FramsClass getInfoFromCache(String identifier) {
-		if (identifier == null) {
-			return null;
-		}
+	public FramsClass getFramsClass(@Nonnull String identifier) {
 		return framsClasses.get(identifier);
 	}
 
-	public static AccessInterface wrapAccessWithListIfNeeded(CompositeParam param, AccessInterface access) {
-		if (access == null) {
-			return null;
-		}
+	public static @Nonnull AccessInterface wrapAccessWithListIfNeeded(@Nonnull CompositeParam param, @Nonnull AccessInterface access) {
 		return param.prepareAccessInterface(access);
 	}
 
-	public AccessInterface prepareAccess(CompositeParam param) throws ConstructionException {
+	public @Nonnull AccessInterface prepareAccess(CompositeParam param) throws ConstructionException {
 		return wrapAccessWithListIfNeeded(param, createAccess(param.getContainedTypeName()));
 	}
 
-	public AccessInterface createAccess(String name) throws ConstructionException {
-		if (name == null) {
-			return null;
+	public @Nonnull AccessInterface createAccess(@Nonnull String name) throws ConstructionException {
+		try {
+			FramsClass framsClass = getFramsClass(name);
+			if (framsClass == null) {
+				throw new ConstructionException().msg("framsclass is missing");
+			}
+
+			return createAccess(name, framsClass);
 		}
-		FramsClass framsClass = getInfoFromCache(name);
-		if (framsClass == null) {
-			return null;
+		catch (FramsticksException e) {
+			throw new FramsticksException().msg("failed to create access for name").arg("name", name).cause(e);
 		}
-
-		return createAccess(name, framsClass);
 	}
 
@@ -96,7 +117,22 @@
 	}
 
-	public Set<FramsClass> getInfoCache() {
+	public Set<FramsClass> getFramsClasses() {
 		return framsClasses.getValues();
 	}
 
+	@ParamAnnotation
+	public Map<String, FramsClass> getFramsClassesById() {
+		return framsClasses.getValuesById();
+	}
+
+	public void takeAllFrom(Registry source) {
+		for (Class<?> javaClass : source.getReflectedClasses()) {
+			register(javaClass);
+		}
+		for (FramsClass framsClass : source.getFramsClasses()) {
+			putFramsClass(framsClass);
+		}
+
+	}
+
 }
Index: /java/main/src/main/java/com/framsticks/params/SimpleAbstractAccess.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/SimpleAbstractAccess.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/params/SimpleAbstractAccess.java	(revision 90)
@@ -78,8 +78,8 @@
 	}
 
-	@Override
-	public Param getGroupMember(int gi, int n) {
-		return framsClass.getGroupMember(gi, n);
-	}
+	// @Override
+	// public Param getGroupMember(int gi, int n) {
+	// 	return framsClass.getGroupMember(gi, n);
+	// }
 
 	@Override
Index: /java/main/src/main/java/com/framsticks/params/UniqueListAccess.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/UniqueListAccess.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/params/UniqueListAccess.java	(revision 90)
@@ -45,5 +45,5 @@
 		}
 		//TODO list access here
-		return Param.build().id(id).name(elementAccess.getId()).type("o " + elementAccess.getId()).finish();
+		return Param.build().id(id).forAccess(elementAccess).finish();
 	}
 
Index: /java/main/src/main/java/com/framsticks/params/Util.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/Util.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/params/Util.java	(revision 90)
@@ -3,4 +3,6 @@
 import java.util.ArrayList;
 import java.util.List;
+
+import com.framsticks.util.FramsticksException;
 
 
@@ -22,8 +24,12 @@
 	}
 
-	public static List<Object> stripAccessInterface(List<AccessInterface> accesses) {
-		List<Object> result = new ArrayList<Object>();
+	public static <T> List<T> stripAccessInterface(List<AccessInterface> accesses, Class<T> type) {
+		List<T> result = new ArrayList<T>();
 		for (AccessInterface a : accesses) {
-			result.add(a.getSelected());
+			Object object = a.getSelected();
+			if (!type.isInstance(object)) {
+				throw new FramsticksException().msg("extracted object is of invalid type").arg("object", object).arg("desired", type).arg("actual", object.getClass()).arg("framsclass", a.getFramsClass());
+			}
+			result.add(type.cast(object));
 		}
 		return result;
Index: /java/main/src/main/java/com/framsticks/params/annotations/FramsClassAnnotation.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/annotations/FramsClassAnnotation.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/params/annotations/FramsClassAnnotation.java	(revision 90)
@@ -11,3 +11,5 @@
 	String name() default "";
 	String id() default "";
+
+	String[] order() default {};
 }
Index: /java/main/src/main/java/com/framsticks/params/annotations/ParamAnnotation.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/annotations/ParamAnnotation.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/params/annotations/ParamAnnotation.java	(revision 90)
@@ -6,4 +6,6 @@
 import java.lang.annotation.Target;
 
+import com.framsticks.params.Param;
+
 @Retention(RetentionPolicy.RUNTIME)
 @Target({ElementType.FIELD, ElementType.METHOD})
@@ -11,4 +13,16 @@
 	String name() default "";
 	String id() default "";
+
+	Class<? extends Param> paramType() default Param.class;
+	String stringType() default "";
+
+	String def() default "";
+	String min() default "";
+	String max() default "";
+
+	String help() default "";
+	// int flags() default 0;
+	int extra() default 0;
+	// String group() default "";
 }
 
Index: /java/main/src/main/java/com/framsticks/params/types/ObjectParam.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/types/ObjectParam.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/params/types/ObjectParam.java	(revision 90)
@@ -15,6 +15,9 @@
 public class ObjectParam extends CompositeParam {
 
+	protected final Class<?> storageType;
+
 	public ObjectParam(ParamBuilder builder) {
-		super(builder);
+		super(builder.fillStorageType(Object.class));
+		storageType = builder.getStorageType();
 	}
 
@@ -26,9 +29,12 @@
 	@Override
 	public Class<?> getStorageType() {
-		return Object.class;
+		return storageType;
 	}
 
 	@Override
 	public ReassignResult<Object> reassign(Object newValue, Object oldValue) throws CastFailure {
+		if (newValue != null && !storageType.isInstance(newValue)) {
+			throw new CastFailure();
+		}
 		return ReassignResult.create(newValue);
 	}
Index: /java/main/src/main/java/com/framsticks/params/types/ProcedureParam.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/types/ProcedureParam.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/params/types/ProcedureParam.java	(revision 90)
@@ -3,11 +3,7 @@
 import com.framsticks.params.Param;
 import com.framsticks.params.ParamBuilder;
-import com.framsticks.util.FramsticksException;
-import com.framsticks.util.lang.Strings;
+import com.framsticks.params.ValueParam;
 
-import java.util.ArrayList;
 import java.util.List;
-import java.util.regex.Matcher;
-import java.util.regex.Pattern;
 
 import javax.annotation.concurrent.Immutable;
@@ -18,8 +14,6 @@
 @Immutable
 public class ProcedureParam extends Param {
-	private final Param resultType;
-	private final List<Param> argumentsType = new ArrayList<Param>();
-
-	private static Pattern addressPattern = Pattern.compile("^([^\\(]+)?\\(([^\\)]*)\\)$");
+	private final ValueParam resultType;
+	private final List<ValueParam> argumentsType;
 
 	/**
@@ -28,36 +22,7 @@
 	public ProcedureParam(ParamBuilder builder) {
 		super(builder);
-		String signature = builder.getProcedureSignature();
-		if (Strings.notEmpty(signature)) {
-			Matcher matcher = addressPattern.matcher(signature);
-			if (!matcher.matches()) {
-				throw new FramsticksException().msg("invalid signature");
-			}
-			String result = Strings.collapse(matcher.group(1));
-			resultType = (result != null) ? parseType(result, null) : null;
-			String arguments = matcher.group(2);
-			if (!Strings.notEmpty(arguments)) {
-				return;
-			}
-			for (String a : arguments.split(",")) {
-				int space = a.indexOf(' ');
-				String type;
-				String name;
-				if (space == -1) {
-					type = a;
-					name = null;
-				} else {
-					type = a.substring(0, space);
-					name = a.substring(space + 1);
-				}
-				argumentsType.add(parseType(type, name));
-			}
-		} else {
-			resultType = null;
-		}
-	}
-
-	protected static Param parseType(String type, String name) {
-		return Param.build().type(type).name(name).finish();
+		resultType = builder.getResultType();
+		argumentsType = builder.getArgumentsType();
+		assert argumentsType != null;
 	}
 
@@ -67,9 +32,9 @@
 	}
 
-	public Param getResultType() {
+	public ValueParam getResultType() {
 		return resultType;
 	}
 
-	public List<Param> getArgumentsType() {
+	public List<ValueParam> getArgumentsType() {
 		return argumentsType;
 	}
Index: /java/main/src/main/java/com/framsticks/parsers/F0Parser.java
===================================================================
--- /java/main/src/main/java/com/framsticks/parsers/F0Parser.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/parsers/F0Parser.java	(revision 90)
@@ -18,4 +18,5 @@
 import com.framsticks.params.Param;
 import com.framsticks.params.PrimitiveParam;
+import com.framsticks.util.FramsticksException;
 import com.framsticks.util.lang.Containers;
 import com.framsticks.util.lang.Pair;
@@ -82,6 +83,5 @@
 	 *             the parse exception
 	 */
-	public List<AccessInterface> parse() throws IOException,
-			ParseException {
+	public List<AccessInterface> parse() {
 
 		try (InputStreamReader reader = new InputStreamReader(is, "UTF-8")) {
@@ -114,4 +114,6 @@
 				result.add(0, processLine("m:"));
 			}
+		} catch (IOException e) {
+			throw new FramsticksException().msg("failed to parse f0").arg("parser", this).arg("schema", schema).cause(e);
 		}
 
Index: /java/main/src/main/java/com/framsticks/parsers/XmlLoader.java
===================================================================
--- /java/main/src/main/java/com/framsticks/parsers/XmlLoader.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/parsers/XmlLoader.java	(revision 90)
@@ -2,4 +2,6 @@
 
 import java.io.InputStream;
+import java.util.LinkedList;
+import java.util.List;
 
 import javax.xml.parsers.DocumentBuilder;
@@ -15,4 +17,5 @@
 import com.framsticks.params.AccessInterface;
 import com.framsticks.params.Registry;
+import com.framsticks.util.AutoBuilder;
 import com.framsticks.util.FramsticksException;
 
@@ -86,6 +89,16 @@
 			}
 
-			if (!access.tryAutoAppend(childObject)) {
-				throw new FramsticksException().msg("failed to auto append").arg("child", childObject).arg("parent", object);
+			List<Object> childrenObjects = new LinkedList<>();
+
+			if (childObject instanceof AutoBuilder) {
+				childrenObjects.addAll(((AutoBuilder) childObject).autoFinish());
+			} else {
+				childrenObjects.add(childObject);
+			}
+
+			for (Object child : childrenObjects) {
+				if (!access.tryAutoAppend(child)) {
+					throw new FramsticksException().msg("failed to auto append").arg("child", child).arg("parent", object);
+				}
 			}
 		}
@@ -112,5 +125,5 @@
 	}
 
-	public <T> T load(InputStream stream, Class<T> type) {
+	public <T> T load(Class<T> type, InputStream stream) {
 		registry.registerAndBuild(type);
 
Index: /java/main/src/main/java/com/framsticks/portals/Portal.java
===================================================================
--- /java/main/src/main/java/com/framsticks/portals/Portal.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/portals/Portal.java	(revision 90)
@@ -58,5 +58,5 @@
 				}
 				final String path = "/simulator/genepools/groups/0/genotypes";
-				instance.invokeLater(new RunAt<Instance>() {
+				instance.dispatch(new RunAt<Instance>() {
 					@Override
 					public void run() {
Index: /java/main/src/main/java/com/framsticks/remote/RecursiveFetcher.java
===================================================================
--- /java/main/src/main/java/com/framsticks/remote/RecursiveFetcher.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/remote/RecursiveFetcher.java	(revision 90)
@@ -52,5 +52,5 @@
 				if (childPath.isResolved() && instance.getInfoFromCache(childPath) != null) {
 					++dispatched;
-					instance.invokeLater(new RunAt<Instance>() {
+					instance.dispatch(new RunAt<Instance>() {
 						@Override
 						public void run() {
Index: /java/main/src/main/java/com/framsticks/remote/RemoteInstance.java
===================================================================
--- /java/main/src/main/java/com/framsticks/remote/RemoteInstance.java	(revision 89)
+++ /java/main/src/main/java/com/framsticks/remote/RemoteInstance.java	(revision 90)
@@ -12,4 +12,5 @@
 import com.framsticks.params.annotations.ParamAnnotation;
 import com.framsticks.params.types.EventParam;
+import com.framsticks.params.types.ProcedureParam;
 import com.framsticks.parsers.MultiParamLoader;
 import com.framsticks.core.Instance;
@@ -82,5 +83,5 @@
 						}
 
-						invokeLater(new RunAt<Instance>() {
+						dispatch(new RunAt<Instance>() {
 							@Override
 							public void run() {
@@ -103,5 +104,5 @@
 											@Override
 											public void call(List<File> files) {
-												invokeLater(new RunAt<Instance>() {
+												dispatch(new RunAt<Instance>() {
 													@Override
 													public void run() {
@@ -361,5 +362,5 @@
 				log.debug("subscribed for change event for " + path);
 				// subscription.setDispatcher(RemoteInstance.this);
-				RemoteInstance.this.invokeLater(new RunAt<Instance>() {
+				RemoteInstance.this.dispatch(new RunAt<Instance>() {
 					@Override
 					public void run() {
@@ -497,5 +498,4 @@
 	}
 
-
 	@Override
 	public void childChangedState(Joinable joinable, JoinableState state) {
@@ -503,4 +503,8 @@
 	}
 
+	@Override
+	public void call(Path path, ProcedureParam param, Object[] arguments, StateFunctor stateFunctor) {
+		throw new UnimplementedException();
+	}
 
 }
